Imports System.IO
Imports System.text
Imports System.Collections
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Drawing.Drawing2D




Public Class ImageResize


    '-----------------------------------------------------
    ' if height = 0, then it determines the thumbnail height
    ' based on the proportion of the width to the original image
    '-----------------------------------------------------

    Private bWatermark As Boolean = False
    Private ThumbNail_watermark As String = "TEST"
    'Private WatermarkImage As String = HttpContext.Current.Server.MapPath("/") & "/images/sample_400x300.gif"
    Private WatermarkImage As String = HttpContext.Current.Server.MapPath("/") & "/images/pec_watermark_475.gif"
    Private ThumbNailName As String = "_thumb"
    Private ThumbNailSize As Size = New Size(0, 0)
    Private ThumbNailSize_max As Size = New Size(0, 0)

    Public Property UseWatermark() As Boolean
        Get
            Return bWatermark
        End Get
        Set(ByVal val As Boolean)
            bWatermark = val
        End Set
    End Property
    Public Property Thumbnailwatermark() As String
        Get
            Return ThumbNail_watermark
        End Get
        Set(ByVal watermark As String)
            ThumbNail_watermark = watermark
        End Set
    End Property
    Public Property Thumbnail_suffix() As String
        Get
            Return ThumbNailName
        End Get
        Set(ByVal file_suffix As String)
            ThumbNailName = file_suffix
        End Set
    End Property
    Public Property Thumbnail_size() As Size
        Get
            Return ThumbNailSize
        End Get
        Set(ByVal newsize As Size)
            ThumbNailSize = newsize
        End Set
    End Property
    Public Property Thumbnail_size_max() As Size
        Get
            Return ThumbNailSize_max
        End Get
        Set(ByVal newsize As Size)
            ThumbNailSize_max = newsize
        End Set
    End Property
    Public Property Watermark_Image() As String
        Get
            Return WatermarkImage
        End Get
        Set(ByVal full_path_image As String)
            WatermarkImage = full_path_image
        End Set
    End Property


    Public Function isThumbnailFolder(ByVal FolderName As String, Optional ByVal full_path As Boolean = False) As Boolean
        Dim find As Boolean = False
        Dim sPhysicalPath As String = ""
        If (Not full_path) Then
            sPhysicalPath = HttpContext.Current.Server.MapPath(FolderName)
        Else
            sPhysicalPath = FolderName
        End If
        Dim oDir As DirectoryInfo = New DirectoryInfo(sPhysicalPath)
        Try
            Dim oSubDirs As DirectoryInfo() = oDir.GetDirectories
            For Each osubdir As DirectoryInfo In oSubDirs
                If (osubdir.Name.IndexOf("thumbnails") > 0) Then find = True
            Next
        Catch ex As Exception
        End Try
        Return find
    End Function



    '------------------------------------------------------------
    ' Will return error codes:
    '   0 = okay
    '   1 = security issue/failed
    '   2 = Other issue
    '------------------------------------------------------------
    Public Function GenerateThumbNailImagesForFolder(ByVal FolderName_orig As String, ByVal FolderName_thumb As String, Optional ByVal full_path_orig As Boolean = False, Optional ByVal full_path_thumb As Boolean = False) As Integer
        HttpContext.Current.Trace.Write("inside GenerateThumbNailImagesForFolder")
        Dim returnCode As Integer = 2

        Dim sPhysicalPath_orig As String = ""
        Dim sPhysicalPath_thumb As String = ""
        Dim sFileName As String = ""
        Dim sThumbName As String = ""
        Dim nImages As Integer = 0
        Dim nThumbs_created As Integer = 0

        If (Not full_path_orig) Then
            sPhysicalPath_orig = HttpContext.Current.Server.MapPath(FolderName_orig)
        Else
            sPhysicalPath_orig = FolderName_orig
        End If
        If (Not full_path_thumb) Then
            sPhysicalPath_thumb = HttpContext.Current.Server.MapPath(FolderName_thumb)
        Else
            sPhysicalPath_thumb = FolderName_thumb
        End If

        HttpContext.Current.Trace.Write("GenerateThumbNailImagesForFolder", "path orig=" & sPhysicalPath_orig & ", thumbs=" & sPhysicalPath_thumb)
        Dim oDir_orig As DirectoryInfo = New DirectoryInfo(sPhysicalPath_orig)
        Dim oDir_thumb As DirectoryInfo = New DirectoryInfo(sPhysicalPath_thumb)

        Try
            If (sPhysicalPath_thumb <> sPhysicalPath_orig) Then
                '--make sure the thumbnail folder exists
                createFolder(sPhysicalPath_thumb)
            End If
        Catch ex As Exception
            HttpContext.Current.Trace.Warn("GenerateThumbnailImages", "Error: " & ex.Message & ", " & ex.StackTrace)
            Return 1
        End Try

        Try
            '--remove all existing thumbnails
            Dim oDeleteFiles As FileInfo() = oDir_thumb.GetFiles()
            For Each oFile As FileInfo In oDeleteFiles
                sFileName = oFile.Name.ToLower()
                If (sFileName.IndexOf(Me.ThumbNailName) > 0) Then
                    'HttpContext.Current.Trace.Write("Removing file: " & ofile.FullName)
                    oFile.Delete()
                End If
            Next


            Dim oFiles As FileInfo() = oDir_orig.GetFiles()
            For Each oFile As FileInfo In oFiles
                nImages += 1

                sFileName = oFile.Name.ToLower()
                sThumbName = sFileName.Replace(".", Me.ThumbNailName + ".")

                If (sFileName.IndexOf(".gif") > 0) Then
                    If (Me.GenerateThumbNail(sPhysicalPath_orig, sPhysicalPath_thumb, sFileName, sThumbName, ImageFormat.Gif)) Then
                        nThumbs_created += 1
                    End If
                End If
                If (sFileName.IndexOf(".jpg") > 0) Then
                    If (Me.GenerateThumbNail(sPhysicalPath_orig, sPhysicalPath_thumb, sFileName, sThumbName, ImageFormat.Jpeg, True)) Then
                        nThumbs_created += 1
                    End If
                End If
                If (sFileName.IndexOf(".bmp") > 0) Then
                    If (Me.GenerateThumbNail(sPhysicalPath_orig, sPhysicalPath_thumb, sFileName, sThumbName, ImageFormat.Bmp)) Then
                        nThumbs_created += 1
                    End If
                End If
            Next

            HttpContext.Current.Trace.Write("GenerateThumbs", "Total Images: " & nImages & ", Thumbs created: " & nThumbs_created)
            Return 0    '--successful creation of thumbnails

        Catch ex As Exception
            HttpContext.Current.Trace.Warn("GenerateThumbNailImagesForFolder", "Error: " & ex.Message & "; " & ex.StackTrace)
            If InStr(ex.Message, " is denied.") Then
                Return 1        '--security permissions
            Else
                Return 2
            End If
        End Try

    End Function


    '------------------------------------------------------------
    ' Will return error codes:
    '   0 = okay
    '   1 = security issue/failed
    '   2 = Other issue
    '------------------------------------------------------------
    Public Function GenerateThumbNail_forFileList(ByVal FolderName_orig As String, ByVal aFileList As ArrayList, ByVal FolderName_thumb As String, Optional ByVal full_path_orig As Boolean = False, Optional ByVal full_path_thumb As Boolean = False) As Integer
        HttpContext.Current.Trace.Write("inside GenerateThumbNailImagesForFolder")
        Dim returnCode As Integer = 2

        Dim sPhysicalPath_orig As String = ""
        Dim sPhysicalPath_thumb As String = ""
        Dim sFileName As String = ""
        Dim sThumbName As String = ""
        Dim nImages As Integer = 0
        Dim nThumbs_created As Integer = 0

        If (Not full_path_orig) Then
            sPhysicalPath_orig = HttpContext.Current.Server.MapPath(FolderName_orig)
        Else
            sPhysicalPath_orig = FolderName_orig
        End If
        If (Not full_path_thumb) Then
            sPhysicalPath_thumb = HttpContext.Current.Server.MapPath(FolderName_thumb)
        Else
            sPhysicalPath_thumb = FolderName_thumb
        End If

        HttpContext.Current.Trace.Write("GenerateThumbNailImagesForFolder", "path orig=" & sPhysicalPath_orig & ", thumbs=" & sPhysicalPath_thumb)
        Dim oDir_orig As DirectoryInfo = New DirectoryInfo(sPhysicalPath_orig)
        Dim oDir_thumb As DirectoryInfo = New DirectoryInfo(sPhysicalPath_thumb)

        Try
            If (sPhysicalPath_thumb <> sPhysicalPath_orig) Then
                '--make sure the thumbnail folder exists
                createFolder(sPhysicalPath_thumb)
            End If
        Catch ex As Exception
            HttpContext.Current.Trace.Warn("GenerateThumbnailImages", "Error: " & ex.Message & ", " & ex.StackTrace)
            Return 1
        End Try

        Dim x As Integer = 0
        Try
            '--remove all existing thumbnails
            Dim filename As String = ""
            For x = 0 To aFileList.Count - 1
                If InStr(aFileList(x), ".") Then
                    filename = Replace(aFileList(x), ".", Me.Thumbnail_suffix & ".")
                    Dim thumbFile As New FileInfo(sPhysicalPath_thumb & "/" & filename)
                    If (thumbFile.Exists) Then
                        thumbFile.Delete()
                    End If
                End If
            Next


            For x = 0 To aFileList.Count - 1
                Dim oFile As New FileInfo(sPhysicalPath_orig & "/" & aFileList(x))
                If (oFile.Exists) Then
                    nImages += 1

                    sFileName = oFile.Name.ToLower()
                    sThumbName = sFileName.Replace(".", Me.ThumbNailName + ".")

                    If (sFileName.IndexOf(".gif") > 0) Then
                        If (Me.GenerateThumbNail(sPhysicalPath_orig, sPhysicalPath_thumb, sFileName, sThumbName, ImageFormat.Gif)) Then
                            nThumbs_created += 1
                        End If
                    End If
                    If (sFileName.IndexOf(".jpg") > 0) Then
                        If (Me.GenerateThumbNail(sPhysicalPath_orig, sPhysicalPath_thumb, sFileName, sThumbName, ImageFormat.Jpeg, True)) Then
                            nThumbs_created += 1
                        End If
                    End If
                    If (sFileName.IndexOf(".bmp") > 0) Then
                        If (Me.GenerateThumbNail(sPhysicalPath_orig, sPhysicalPath_thumb, sFileName, sThumbName, ImageFormat.Bmp)) Then
                            nThumbs_created += 1
                        End If
                    End If
                End If
            Next

            HttpContext.Current.Trace.Write("GenerateThumbs", "Total Images: " & nImages & ", Thumbs created: " & nThumbs_created)
            Return 0    '--successful creation of thumbnails

        Catch ex As Exception
            HttpContext.Current.Trace.Warn("GenerateThumbNailImagesForFolder", "Error: " & ex.Message & "; " & ex.StackTrace)
            If InStr(ex.Message, " is denied.") Then
                Return 1        '--security permissions
            Else
                Return 2
            End If
        End Try

    End Function



    '--------------------------------------------------------
    ' generate the actual thumbnail here
    '--------------------------------------------------------
    Public Function GenerateThumbNail(ByVal sPhysicalPath_orig As String, ByVal sPhysicalPath_thumb As String, ByVal sOrgFileName As String, ByVal sThumbNailFileName As String, ByVal oFormat As ImageFormat, Optional ByVal rotateClockwise As Boolean = False, Optional ByVal rotateCounterClockwise As Boolean = False, Optional ByVal rotateFlipVertical As Boolean = False) As Boolean
        Dim oImg As System.Drawing.Image
        Try
            oImg = System.Drawing.Image.FromFile(sPhysicalPath_orig & "\" & sOrgFileName)
        Catch ex As Exception
            HttpContext.Current.Trace.Warn("GenerateThumbnail", "Error with img: " & sOrgFileName & " -- " & ex.Message & "; " & ex.StackTrace)
            Return False
        End Try
        Try
            If (sThumbNailFileName = "") Then
                sThumbNailFileName = Mid(sOrgFileName, 1, InStr(sOrgFileName, ".") - 1) & Thumbnail_suffix & Mid(sOrgFileName, InStr(sOrgFileName, "."))
                HttpContext.Current.Trace.Warn("thumbnail=" & sThumbNailFileName)
            End If

            If (rotateFlipVertical) Then
                oImg.RotateFlip(RotateFlipType.Rotate180FlipNone)
                HttpContext.Current.Trace.Write("rotating image flip-vertical: " & sPhysicalPath_thumb & "\" & sThumbNailFileName)
            ElseIf (rotateClockwise) Then
                oImg.RotateFlip(RotateFlipType.Rotate90FlipNone)
                HttpContext.Current.Trace.Write("rotating image clockwise: " & sPhysicalPath_thumb & "\" & sThumbNailFileName)
            ElseIf (rotateCounterClockwise) Then
                oImg.RotateFlip(RotateFlipType.Rotate270FlipNone)
                HttpContext.Current.Trace.Write("rotating image counter-clock: " & sPhysicalPath_thumb & "\" & sThumbNailFileName)
            End If
            Dim height As Integer = Me.ThumbNailSize.Height
            Dim width As Integer = Me.ThumbNailSize.Width
            If (height <= 0) And (width > 0) Then
                '--get the height based upon the image proportions
                Dim widthpct As Double = CDbl(Me.ThumbNailSize.Width / oImg.Width)
                'HttpContext.Current.Trace.Write("generateThumbnail", "widthpct=" & widthpct)
                height = oImg.Height * widthpct
                Me.ThumbNailSize.Height = height
            ElseIf (width <= 0) And (height > 0) Then
                '--get the width based upon the image proportions
                Dim heightpct As Double = CDbl(Me.ThumbNailSize.Height / oImg.Height)
                'HttpContext.Current.Trace.Write("generateThumbnail", "heightpct=" & heightpct)
                width = oImg.Width * heightpct
                Me.ThumbNailSize.Width = width
            End If
            '---------------------------------------------------------
            ' RV 4/20/06 checking on max width & height constraints
            '---------------------------------------------------------
            If (Me.ThumbNailSize_max.Width > 0) Then
                '--see if the image has already been resized
                If (ThumbNailSize.Width > ThumbNailSize_max.Width) Or (ThumbNailSize.Width <= 0) Then
                    '--resize, keeping the proportions
                    ThumbNailSize.Width = ThumbNailSize_max.Width
                    Dim widthpct As Double = CDbl(Me.ThumbNailSize.Width / oImg.Width)
                    height = oImg.Height * widthpct
                    Me.ThumbNailSize.Height = height
                End If
            End If
            If (Me.ThumbNailSize_max.Height > 0) Then
                '--see if the image has already been resized
                If (ThumbNailSize.Height > ThumbNailSize_max.Height) Or (ThumbNailSize.Height <= 0) Then
                    '--resize, keeping the proportions
                    ThumbNailSize.Height = ThumbNailSize_max.Height
                    Dim heightpct As Double = CDbl(Me.ThumbNailSize.Height / oImg.Height)
                    width = oImg.Width * heightpct
                    Me.ThumbNailSize.Width = width
                End If
            End If


            HttpContext.Current.Trace.Write("generateThumbnail", "width=" & Me.ThumbNailSize.Width & ", height=" & height)
            Dim oThumbNail As System.Drawing.Image = New Bitmap(Me.ThumbNailSize.Width, Me.ThumbNailSize.Height, oImg.PixelFormat)
            Dim oGraphic As Graphics = Graphics.FromImage(oThumbNail)
            '--RV 6/13/06 setting to default quality
            'oGraphic.CompositingQuality = CompositingQuality.HighSpeed
            oGraphic.CompositingQuality = CompositingQuality.Default
            'oGraphic.SmoothingMode = SmoothingMode.HighSpeed
            oGraphic.SmoothingMode = SmoothingMode.Default
            'oGraphic.InterpolationMode = InterpolationMode.HighQualityBicubic
            'oGraphic.InterpolationMode = InterpolationMode.Low
            oGraphic.InterpolationMode = InterpolationMode.Default
            Dim oRectangle As Rectangle = New Rectangle(0, 0, Me.ThumbNailSize.Width, Me.ThumbNailSize.Height)
            oGraphic.DrawImage(oImg, oRectangle)

            If (bWatermark) Then
                '--use the watermark image
                'Dim myFont As New Font("Arial", 13, FontStyle.Bold, GraphicsUnit.Pixel)
                'OverlayText(oGraphic, ThumbNail_watermark, myFont, Color.White, True, True, ContentAlignment.MiddleRight)
                OverlayImage(oThumbNail)
            End If

            'Dim objBrush2 As New SolidBrush(Color.FromArgb(100, Color.Orange))
            'oGraphic.FillRectangle(objBrush2, 0, 0, 20, 20)

            Dim thumbpath As String = sPhysicalPath_thumb & "\" & sThumbNailFileName
            thumbpath = Replace(thumbpath, "\\", "\")
            HttpContext.Current.Trace.Warn("generateThumbnail", "path=" & thumbpath)
            oThumbNail.Save(thumbpath, oFormat)

            oThumbNail.Dispose()
            oThumbNail = Nothing
            oImg.Dispose()
            oImg = Nothing
            oGraphic.Dispose()
            oGraphic = Nothing
            oRectangle = Nothing

            Return True
        Catch ex As Exception
            '--try creating basic thumbnail
            HttpContext.Current.Trace.Warn("GenerateThumbNail", "Error: " & ex.Message & "; file=" & sOrgFileName & " (" & sPhysicalPath_thumb & "\" & sThumbNailFileName & "); " & ex.StackTrace)
            If (Not oImg Is Nothing) Then
                Try

                    Dim oThumbnail As System.Drawing.Image = oImg.GetThumbnailImage(Me.ThumbNailSize.Width, Me.ThumbNailSize.Height, Nothing, Nothing)
                    oThumbnail.Save(sPhysicalPath_thumb & "\" & sThumbNailFileName, oFormat)
                    oThumbnail.Dispose()
                    oThumbnail = Nothing
                    Return True
                Catch ex2 As Exception
                    HttpContext.Current.Trace.Warn("GenerateThumbNail", "Error2: " & ex.Message & "; file=" & sOrgFileName & "; " & ex.StackTrace)
                    Return False
                End Try
            End If
        Finally

        End Try
        Return False
    End Function




    

    '---need to make sure the thumbnail folder exists
    Sub createFolder(ByVal sPhysicalPath_thumb As String)
        '--need to get parent folder
        Dim oDirNew As DirectoryInfo = New DirectoryInfo(sPhysicalPath_thumb)
        If (Not oDirNew.Exists) Then
            oDirNew.Create()
        End If
        oDirNew = Nothing
    End Sub





    Public Sub OverlayImage(ByRef imgPhoto As System.Drawing.Image)

        '//create a image object containing the watermark
        Dim imgWatermark As Image = System.Drawing.Image.FromFile(WatermarkImage)
        Dim wmWidth As Integer = imgWatermark.Width
        Dim wmHeight As Integer = imgWatermark.Height

        '//------------------------------------------------------------
        '//Step #2 - Insert Watermark image
        '//------------------------------------------------------------

        '//Create a Bitmap based on the previously modified photograph Bitmap
        'Dim bmWatermark As Bitmap = new Bitmap(bmPhoto)

        'bmWatermark.SetResolution(imgPhoto.HorizontalResolution, imgPhoto.VerticalResolution)
        '//Load this Bitmap into a new Graphic Object

        'Dim grWatermark As Graphics = Graphics.FromImage(bmWatermark)
        Dim grWatermark As Graphics = Graphics.FromImage(imgPhoto)

        '//To achieve a transulcent watermark we will apply (2) color 
        '//manipulations by defineing a ImageAttributes object and 
        '//seting (2) of its properties.
        Dim imgAttributes As ImageAttributes = New ImageAttributes

        '//The first step in manipulating the watermark image is to replace 
        '//the background color with one that is trasparent (Alpha=0, R=0, G=0, B=0)
        '//to do this we will use a Colormap and use this to define a RemapTable
        Dim clrMap As ColorMap = New ColorMap

        '//My watermark was defined with a background of 100% Green this will
        '//be the color we search for and replace with transparency
        clrMap.OldColor = Color.FromArgb(255, 0, 255, 0)
        clrMap.NewColor = Color.FromArgb(0, 0, 0, 0)


        Dim remapTable As ColorMap() = {clrMap}
        imgAttributes.SetRemapTable(remapTable, ColorAdjustType.Bitmap)

        '//The second color manipulation is used to change the opacity of the 
        '//watermark.  This is done by applying a 5x5 matrix that contains the 
        '//coordinates for the RGBA space.  By setting the 3rd row and 3rd column 
        '//to 0.3f we achive a level of opacity
        Dim colorMatrixElements As Single()() = { _
                  New Single() {1.0F, 0.0F, 0.0F, 0.0F, 0.0F}, _
                  New Single() {0.0F, 1.0F, 0.0F, 0.0F, 0.0F}, _
                  New Single() {0.0F, 0.0F, 1.0F, 0.0F, 0.0F}, _
                  New Single() {0.0F, 0.0F, 0.0F, 0.35F, 0.0F}, _
                  New Single() {0.0F, 0.0F, 0.0F, 0.0F, 1.0F}}
        Dim wmColorMatrix As ColorMatrix = New ColorMatrix(colorMatrixElements)

        imgAttributes.SetColorMatrix(wmColorMatrix, ColorMatrixFlag.Default, ColorAdjustType.Bitmap)

        ' we want to put this watermark in the middle of the image,
        ' so we need the size of the watermark image, and the size of the thumbnail

        Dim xPosOfWm As Integer = ((Me.ThumbNailSize.Width - wmWidth) / 2)
        Dim yPosOfWm As Integer = ((Me.ThumbNailSize.Height - wmHeight) / 2)
        HttpContext.Current.Trace.Write("overlayImage", "xPosOfWm=" & xPosOfWm & ",yPosOfWm=" & yPosOfWm)
        If (xPosOfWm < 0) Then xPosOfWm = 0
        If (yPosOfWm < 0) Then yPosOfWm = 0

        '---- resize the watermark image here --------
        If (Me.ThumbNailSize.Width < wmWidth) Then
            '--this is probably a GIF, so need to do it this way...
            imgWatermark = imgWatermark.GetThumbnailImage(Me.ThumbNailSize.Width, Me.ThumbNailSize.Height, Nothing, Nothing)
        End If


        grWatermark.DrawImage(imgWatermark, _
         New Rectangle(xPosOfWm, yPosOfWm, wmWidth, wmHeight), _
         0, 0, wmWidth, wmHeight, GraphicsUnit.Pixel, imgAttributes)            '//ImageAttributes Object

        '//Replace the original photgraphs bitmap with the new Bitmap
        'imgPhoto = bmWatermark

        '//save new image to file system.
        'Dim name As String = Replace(full_imagename, "_thumb", "_wm")
        'imgPhoto.Save(name, ImageFormat.Jpeg)

        '----- garbarge collection --------------
        grWatermark.Dispose()
        grWatermark = Nothing
        clrMap = Nothing
        remapTable = Nothing
        colorMatrixElements = Nothing
        wmColorMatrix = Nothing
        imgAttributes.Dispose()
        imgAttributes = Nothing
        imgWatermark.Dispose()
        imgWatermark = Nothing

    End Sub

    Public Sub OverlayText(ByRef oGraphic As Graphics, ByVal OverlayText As String, _
      ByVal OverlayFont As Font, ByVal OverlayColor As Color, ByVal AddAlpha As Boolean, _
      ByVal AddShadow As Boolean, ByVal Position As Drawing.ContentAlignment)

        Dim myBrush As SolidBrush
        If (AddAlpha) Then
            myBrush = New SolidBrush(Color.FromArgb(150, Color.White))
        Else
            myBrush = New SolidBrush(Color.White)
        End If

        Dim x As Single = Me.ThumbNailSize.Width - OverlayFont.Height - 2
        Dim y As Single = 10
        Dim drawFormat As New StringFormat(StringFormatFlags.DirectionVertical)

        '--now do a drop-shadow
        If (AddShadow) Then
            Dim myBrush_shadow As System.Drawing.SolidBrush
            If (AddAlpha) Then
                myBrush_shadow = New System.Drawing.SolidBrush(Color.FromArgb(200, Color.Black))
            Else
                myBrush_shadow = New System.Drawing.SolidBrush(Color.DarkGray)
            End If

            'Dim rect As New Drawing.RectangleF(0, 0, Me.ThumbNailSize.Width, Me.ThumbNailSize.Height)
            'Dim format As New Drawing.StringFormat(StringFormatFlags.DirectionVertical)
            'format.Alignment = StringAlignment.Far
            'format.LineAlignment = StringAlignment.Far
            'oGraphic.DrawString(OverlayText, OverlayFont, myBrush_shadow, rect, format)
            oGraphic.DrawString(OverlayText, OverlayFont, myBrush_shadow, x - 1, y - 1, drawFormat)
        End If
        oGraphic.DrawString(OverlayText, OverlayFont, myBrush, x, y, drawFormat)
    End Sub

    Shared Function rotateImage(ByVal full_imagename As String, Optional ByVal rotate_clockwise As Boolean = True, Optional ByVal rotate_flipVertical As Boolean = False) As Boolean
        Dim okay As Boolean = False
        If Len(full_imagename) > 0 Then
            full_imagename = Replace(full_imagename, "/", "\")
            full_imagename = Replace(full_imagename, "\\", "\")
        End If
        Dim objFile As New FileInfo(full_imagename)
        If (objFile.Exists) Then
            Dim oImg As System.Drawing.Image
            Try
                objFile = Nothing
                '--RV 7/27/06 loading from a stream helps
                Dim fsImage As New FileStream(full_imagename, FileMode.Open)
                'oImg = System.Drawing.Image.FromFile(full_imagename)
                oImg = System.Drawing.Image.FromStream(fsImage)

                If (rotate_flipVertical) Then
                    oImg.RotateFlip(RotateFlipType.Rotate180FlipNone)
                ElseIf (rotate_clockwise) Then
                    oImg.RotateFlip(RotateFlipType.Rotate90FlipNone)
                Else
                    oImg.RotateFlip(RotateFlipType.Rotate270FlipNone)
                End If
                Dim oThumbNail As System.Drawing.Image = New Bitmap(oImg.Width, oImg.Height, oImg.PixelFormat)
                Dim oGraphic As Graphics = Graphics.FromImage(oThumbNail)
                oGraphic.CompositingQuality = CompositingQuality.HighQuality
                oGraphic.SmoothingMode = SmoothingMode.HighQuality
                oGraphic.InterpolationMode = InterpolationMode.HighQualityBicubic
                Dim oRectangle As Rectangle = New Rectangle(0, 0, oImg.Width, oImg.Height)
                oGraphic.DrawImage(oImg, oRectangle)


                Dim imgFormat As Drawing.Imaging.ImageFormat = ImageFormat.Jpeg
                If (full_imagename.IndexOf(".gif") > 0) Then
                    imgFormat = ImageFormat.Gif
                ElseIf (full_imagename.IndexOf(".bmp") > 0) Then
                    imgFormat = ImageFormat.Bmp
                End If
                Dim newname As String = Replace(full_imagename, ".", "r" & Now().Millisecond & ".")
                '--RV 7/27/06 have to close the Img and Stream before saving
                oImg.Dispose()
                oImg = Nothing
                fsImage.Dispose()
                fsImage = Nothing

                oThumbNail.Save(full_imagename, imgFormat)

                oThumbNail.Dispose()
                oThumbNail = Nothing
                oGraphic.Dispose()
                oGraphic = Nothing
                oRectangle = Nothing

                okay = True
            Catch ex As Exception
                HttpContext.Current.Trace.Warn("rotateImage", "file=" & full_imagename & ", ERROR: " & ex.Message & "; " & ex.StackTrace)
            End Try
        End If
        'objFile = Nothing
        Return okay
    End Function

    Shared Function thumb_matchOrig(ByVal thumbName As String, ByVal aOrig As ArrayList, ByVal thumb_suffix As String) As Boolean
        Dim match As Boolean = False
        For x As Integer = 0 To aOrig.Count - 1
            Dim tmpName As String = aOrig(x)
            tmpName = Replace(aOrig(x), ".", thumb_suffix & ".")
            If (LCase(thumbName) = LCase(tmpName)) Then
                Return True
            End If
        Next
        Return match
    End Function




    ''' <summary>
    ''' This will resize an image
    ''' </summary>
    ''' <param name="sPhysicalPath_orig"></param>
    ''' <param name="sOrgFileName"></param>
    ''' <param name="oFormat"></param>
    ''' <param name="rotateClockwise"></param>
    ''' <param name="rotateCounterClockwise"></param>
    ''' <param name="rotateFlipVertical"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function ResizeImage(ByVal sPhysicalPath_orig As String, ByVal sOrgFileName As String, _
                                ByVal oFormat As ImageFormat, _
                                Optional ByVal rotateClockwise As Boolean = False, _
                                Optional ByVal rotateCounterClockwise As Boolean = False, _
                                Optional ByVal rotateFlipVertical As Boolean = False, _
                                Optional ByRef resizedName As String = "") As Boolean
        Dim oImg As System.Drawing.Image
        Try
            oImg = System.Drawing.Image.FromFile(sPhysicalPath_orig & "\" & sOrgFileName)
        Catch ex As Exception
            HttpContext.Current.Trace.Warn("GenerateThumbnail", "Error with img: " & sOrgFileName & " -- " & ex.Message & "; " & ex.StackTrace)
            Return False
        End Try
        Dim sPhysicalPath_thumb As String = sPhysicalPath_orig
        Dim sThumbNailFileName As String = ""
        Try
            sThumbNailFileName = Mid(sOrgFileName, 1, InStr(sOrgFileName, ".") - 1) & "_th" & Mid(sOrgFileName, InStr(sOrgFileName, "."))
            HttpContext.Current.Trace.Warn("thumbnail=" & sThumbNailFileName)

            If (rotateFlipVertical) Then
                oImg.RotateFlip(RotateFlipType.Rotate180FlipNone)
                HttpContext.Current.Trace.Write("rotating image flip-vertical: " & sPhysicalPath_thumb & "\" & sThumbNailFileName)
            ElseIf (rotateClockwise) Then
                oImg.RotateFlip(RotateFlipType.Rotate90FlipNone)
                HttpContext.Current.Trace.Write("rotating image clockwise: " & sPhysicalPath_thumb & "\" & sThumbNailFileName)
            ElseIf (rotateCounterClockwise) Then
                oImg.RotateFlip(RotateFlipType.Rotate270FlipNone)
                HttpContext.Current.Trace.Write("rotating image counter-clock: " & sPhysicalPath_thumb & "\" & sThumbNailFileName)
            End If
            Dim height As Integer = Me.ThumbNailSize.Height
            Dim width As Integer = Me.ThumbNailSize.Width
            If (height <= 0) And (width > 0) Then
                '--get the height based upon the image proportions
                Dim widthpct As Double = CDbl(Me.ThumbNailSize.Width / oImg.Width)
                'HttpContext.Current.Trace.Write("generateThumbnail", "widthpct=" & widthpct)
                height = oImg.Height * widthpct
                Me.ThumbNailSize.Height = height
            ElseIf (width <= 0) And (height > 0) Then
                '--get the width based upon the image proportions
                Dim heightpct As Double = CDbl(Me.ThumbNailSize.Height / oImg.Height)
                'HttpContext.Current.Trace.Write("generateThumbnail", "heightpct=" & heightpct)
                width = oImg.Width * heightpct
                Me.ThumbNailSize.Width = width
            End If
            '---------------------------------------------------------
            ' RV 4/20/06 checking on max width & height constraints
            '---------------------------------------------------------
            If (Me.ThumbNailSize_max.Width > 0) Then
                '--see if the image has already been resized
                If (ThumbNailSize.Width > ThumbNailSize_max.Width) Or (ThumbNailSize.Width <= 0) Then
                    '--resize, keeping the proportions
                    ThumbNailSize.Width = ThumbNailSize_max.Width
                    Dim widthpct As Double = CDbl(Me.ThumbNailSize.Width / oImg.Width)
                    height = oImg.Height * widthpct
                    Me.ThumbNailSize.Height = height
                End If
            End If
            If (Me.ThumbNailSize_max.Height > 0) Then
                '--see if the image has already been resized
                If (ThumbNailSize.Height > ThumbNailSize_max.Height) Or (ThumbNailSize.Height <= 0) Then
                    '--resize, keeping the proportions
                    ThumbNailSize.Height = ThumbNailSize_max.Height
                    Dim heightpct As Double = CDbl(Me.ThumbNailSize.Height / oImg.Height)
                    width = oImg.Width * heightpct
                    Me.ThumbNailSize.Width = width
                End If
            End If


            HttpContext.Current.Trace.Write("generateThumbnail", "width=" & Me.ThumbNailSize.Width & ", height=" & height)
            Dim oThumbNail As System.Drawing.Image = New Bitmap(Me.ThumbNailSize.Width, Me.ThumbNailSize.Height, oImg.PixelFormat)
            Dim oGraphic As Graphics = Graphics.FromImage(oThumbNail)
            '--RV 6/13/06 setting to default quality
            'oGraphic.CompositingQuality = CompositingQuality.HighSpeed
            oGraphic.CompositingQuality = CompositingQuality.HighQuality
            'oGraphic.SmoothingMode = SmoothingMode.HighSpeed
            oGraphic.SmoothingMode = SmoothingMode.HighQuality
            'oGraphic.InterpolationMode = InterpolationMode.HighQualityBicubic
            'oGraphic.InterpolationMode = InterpolationMode.Low
            oGraphic.InterpolationMode = InterpolationMode.HighQualityBicubic
            Dim oRectangle As Rectangle = New Rectangle(0, 0, Me.ThumbNailSize.Width, Me.ThumbNailSize.Height)
            oGraphic.DrawImage(oImg, oRectangle)


            'Dim objBrush2 As New SolidBrush(Color.FromArgb(100, Color.Orange))
            'oGraphic.FillRectangle(objBrush2, 0, 0, 20, 20)

            Dim thumbpath As String = sPhysicalPath_thumb & "\" & sThumbNailFileName
            thumbpath = Replace(thumbpath, "\\", "\")
            HttpContext.Current.Trace.Warn("generateThumbnail", "path=" & thumbpath)
            oThumbNail.Save(thumbpath, oFormat)
            resizedName = sThumbNailFileName

            oThumbNail.Dispose()
            oThumbNail = Nothing
            oImg.Dispose()
            oImg = Nothing
            oGraphic.Dispose()
            oGraphic = Nothing
            oRectangle = Nothing

            '--now delete the original image, then rename the thumbnail
            Dim f2 As New FileInfo(sPhysicalPath_orig & "\" & sOrgFileName)
            If (Not f2.Exists) Then
            Else
                f2.Delete()
            End If
            f2 = Nothing

            RvDataUtil.Formatting.FileRename(sPhysicalPath_orig, sThumbNailFileName, sOrgFileName, True)

            Return True
        Catch ex As Exception
            '--try creating basic thumbnail
            HttpContext.Current.Trace.Warn("GenerateThumbNail", "Error: " & ex.Message & "; file=" & sOrgFileName & " (" & sPhysicalPath_thumb & "\" & sThumbNailFileName & "); " & ex.StackTrace)
            If (Not oImg Is Nothing) Then
                Try

                    Dim oThumbnail As System.Drawing.Image = oImg.GetThumbnailImage(Me.ThumbNailSize.Width, Me.ThumbNailSize.Height, Nothing, Nothing)
                    oThumbnail.Save(sPhysicalPath_thumb & "\" & sThumbNailFileName, oFormat)
                    oThumbnail.Dispose()
                    oThumbnail = Nothing
                    Return True
                Catch ex2 As Exception
                    HttpContext.Current.Trace.Warn("GenerateThumbNail", "Error2: " & ex.Message & "; file=" & sOrgFileName & "; " & ex.StackTrace)
                    Return False
                End Try
            End If
        Finally

        End Try
        Return False
    End Function

End Class


