Imports System.IO
Imports RvDataUtil.Formatting

Public Class Uploads

    '------------------------------------------------------------------------------
    'Example Usage:
    ' aspx page for user to denote file to save
    '		<tr bgcolor=#ffffff><td >Photo Name:</td>
    '			<td><input type=file runat="server" id="txtSmallPhotoNameUpload" name="txtSmallPhotoNameUpload" class=formitem size=65>
    '				<asp:Panel ID="pnlSmallPhotoName" visible=false runat="server">
    '					<asp:Image ID="imgSmallPhotoName" ImageAlign=Left runat="server" />
    '					<asp:CheckBox ID="chkSmallPhotoNameDel" runat="server" Text="Remove Image from this Item<br>" />
    '					<b><asp:Literal ID="litSmallPhotoName_Error" runat="server" /></b>
    '				</asp:Panel>
    '	    </td></tr>
    '
    ' vb code-behind to save file
    '     Dim SmallPhotoName As String = Uploads.UploadImage(Me.txtSmallPhotoNameUpload, "/images/upload", _
    '                   Me.litSmallPhotoName_Error, Me.imgSmallPhotoName, Me.pnlSmallPhotoName, "photo_")
    '     If (SmallPhotoName = "**error**") Then
    '            Exit Sub
    '     End If
    '------------------------------------------------------------------------------
    Shared Function UploadImage(ByVal uploadField As Web.UI.HtmlControls.HtmlInputFile, _
                            Optional ByVal uploadPath As String = "/userdocs", _
                            Optional ByVal litError As Literal = Nothing, _
                            Optional ByVal imgName As Web.UI.WebControls.Image = Nothing, _
                            Optional ByVal pnl As Panel = Nothing, _
                            Optional ByVal filename_start As String = "", _
                            Optional ByVal checkMaxFileSize As Boolean = True) As String

        Dim strFileName As String = ""
        If Len(uploadField.Value) > 0 Then
            If Not (uploadField.PostedFile Is Nothing) Then
                Try
                    Dim strRemotePath As String = HttpContext.Current.Server.MapPath(uploadPath)
					HttpContext.Current.Trace.Warn("uploadImage", "strRemotePath=" & strRemotePath)
                    Dim postedFile As HttpPostedFile = uploadField.PostedFile
                    strFileName = Path.GetFileName(postedFile.FileName)

                    'strFileName = ViewState("storeid") & "_" & strFileName
                    strFileName = filename_start & strFileName.Replace(" ", "_")
                    Dim contentType As String = postedFile.ContentType
                    Dim contentLength As Integer = postedFile.ContentLength
                    If (checkMaxFileSize) Then
                        Dim maxFileSize As Integer = getDbIntNull(ConfigurationManager.AppSettings("maxFilesize"), 0)
                        If (maxFileSize < (contentLength / 1000)) And (maxFileSize > 0) Then
                            If Not (litError Is Nothing) Then
                                litError.Text = "<span class=error>Unable to upload the file. File size too large (" & contentLength & ")</span><br>"
                                litError.Visible = True
                            End If
                            Return "**error**"
                        End If
                    End If
                    HttpContext.Current.Trace.Warn("full filename", strRemotePath & "\" & strFileName)
                    postedFile.SaveAs(strRemotePath & "\" & strFileName)
                    postedFile = Nothing
                Catch exc As Exception
                    If Not (litError Is Nothing) Then
                        litError.Text = "<span class=error>Unable to upload the file</span><br>"
                        litError.Visible = True
                    End If
                    HttpContext.Current.Trace.Warn("uploads", exc.ToString & "; " & exc.StackTrace)
                    Return "**error**"
                End Try
            Else
                If Not (litError Is Nothing) Then
                    litError.Text = "<span class=error>Nothing was uploaded.</span><br>"
                    litError.Visible = True
                End If
                HttpContext.Current.Trace.Write("uploads", "nothing was uploaded")
                Return "**error**"
            End If
        End If
        'ViewState("imgfile") = strFileName
        If Not (imgName Is Nothing) Then
            imgName.ImageUrl = uploadPath & strFileName
            imgName.Visible = True
        End If
        If Not (pnl Is Nothing) Then
            pnl.Visible = True
        End If
        Return strFileName  '--name of file that was uploaded
    End Function

End Class
